From be9d78d9892795cede47ea2ebf0a5e58aeb43bee Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 11/48] Convert ModuleBuildopts to libmodulemd


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index 7429e3e..757fbd2 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -727,6 +727,7 @@ class ModuleMetadata(object):
         """A ModuleBuildopts instance representing the additional
         module components build options.
         """
+        self._buildopts = ModuleBuildopts(parent=self)
         return self._buildopts
 
     @buildopts.setter
diff --git a/modulemd/buildopts/__init__.py b/modulemd/buildopts/__init__.py
index 5aa7b73..9f4cc11 100644
--- a/modulemd/buildopts/__init__.py
+++ b/modulemd/buildopts/__init__.py
@@ -30,9 +30,11 @@ supported_content = ( "rpms", )
 class ModuleBuildopts(object):
     """Class representing component build options."""
 
-    def __init__(self):
+    def __init__(self, parent=None):
         """Creates a new ModuleBuildopts instance."""
-        self.rpms = ModuleBuildoptsRPMs()
+        self.rpms = ModuleBuildoptsRPMs(parent=parent)
+        self.parent = parent
+
 
     def __repr__(self):
         return ("<ModuleBuildopts: "
@@ -57,3 +59,8 @@ class ModuleBuildopts(object):
         if not isinstance(o, ModuleBuildoptsRPMs):
             raise TypeError("buildopts.rpms: data type not supported")
         self._rpms = o
+
+        if hasattr(self, 'parent') and self.parent is not None:
+            opts = dict()
+            opts['macros'] = o.macros
+            self.parent.set_buildopts(opts)
diff --git a/modulemd/buildopts/rpms.py b/modulemd/buildopts/rpms.py
index 908684b..6dc0640 100644
--- a/modulemd/buildopts/rpms.py
+++ b/modulemd/buildopts/rpms.py
@@ -28,10 +28,26 @@ from modulemd.buildopts.base import ModuleBuildoptsBase
 class ModuleBuildoptsRPMs(ModuleBuildoptsBase):
     """A buildopts class for handling RPM content build options."""
 
-    def __init__(self, macros=""):
+    def __init__(self, macros="", parent=None):
         """Creates a new ModuleBuildoptsRPMs instance."""
         super(ModuleBuildoptsRPMs, self).__init__()
         self.macros = macros
+        self.parent = parent
+
+        # If macros were specified at initialization, update the
+        # module with it
+        if self.macros:
+            if hasattr(self, 'parent'):
+                opts = dict()
+                opts['macros'] = self.macros
+                self.parent.module.set_rpm_buildopts(opts)
+            return
+
+        if parent:
+            m = self.parent.module.get_rpm_buildopts()
+            if 'macros' in m:
+                self.macros = m['macros']
+
 
     def __repr__(self):
         return ("<ModuleBuildoptsRPMs: "
@@ -56,3 +72,8 @@ class ModuleBuildoptsRPMs(ModuleBuildoptsBase):
         if not isinstance(s, str):
             raise TypeError("buildoptsrpm.macros: data type not supported")
         self._macros = s
+
+        if hasattr(self, 'parent') and self.parent is not None:
+            opts = dict()
+            opts['macros'] = self.macros
+            self.parent.module.set_rpm_buildopts(opts)

